BuildRequires: qdox16-poms
Requires: qdox16-poms
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

Name:           maven-plugin-tools
Version:        2.4.3
Release:        alt2_4jpp6
Epoch:          0
Summary:        Maven Plugin Tools
License:        ASL 2.0
Group:          Development/Java
URL:            http://maven.apache.org/plugin-tools/
Source0:        %{name}-%{version}-src.tar.gz
# svn export https://svn.apache.org/repos/asf/maven/shared/tags/maven-plugin-tools-2.4.3
# tar czf maven-plugin-tools-2.4.3-src.tar.gz maven-plugin-tools-2.4.3
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Patch0:         %{name}-pom.patch
Patch1:         %{name}-model-pom.patch
Patch2:         %{name}-plugin-plugin-pom.patch


%if ! %{gcj_support}
BuildArch:      noarch
%endif

BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: ant >= 0:1.7
BuildRequires: junit
BuildRequires: maven2 >= 0:2.0.8
BuildRequires: maven2-plugin-antrun
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-plugin
BuildRequires: maven2-plugin-release
BuildRequires: maven2-plugin-site
BuildRequires: maven-surefire-maven-plugin
BuildRequires: maven-surefire-provider-junit
BuildRequires: maven-doxia
BuildRequires: maven-doxia-sitetools
BuildRequires: maven-shared-filtering
BuildRequires: maven-shared-plugin-tools-ant
BuildRequires: maven-shared-plugin-testing-harness
BuildRequires: maven-shared-reporting-impl
BuildRequires: modello
BuildRequires: mojo-maven2-plugin-l10n
BuildRequires: mojo-maven2-plugin-l10n
BuildRequires: bsh
BuildRequires: plexus-container-default
BuildRequires: plexus-utils
BuildRequires: jtidy
BuildRequires: qdox >= 0:1.6.3
BuildRequires: apache-commons-parent

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
Provides:       maven2-plugin-plugin = %{epoch}:%{version}-%{release}
Obsoletes:      maven2-plugin-plugin < %{epoch}:%{version}-%{release}
Requires: bsh
Requires: jtidy
Requires: maven2 >= 0:2.0.8
Requires: maven-doxia
Requires: maven-doxia-sitetools
Requires: maven-shared-reporting-impl
Requires: plexus-container-default
Requires: plexus-utils
Requires: qdox >= 0:1.6.3

%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
Source44: import.info
Patch33: maven-plugin-tools-2.4.3-alt-fresh-tidy-support.patch

%description
The Maven Plugin Tools contains the necessary tools to be 
able to produce Maven Plugins in a variety of languages.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires: jpackage-utils
BuildArch: noarch

%description javadoc
Javadoc for %{name}.

%prep
%setup -q
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch33 -p0
#rm -rf maven-plugin-plugin

%build
cp %{SOURCE1} settings.xml
sed -i -e "s|<url>__INTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" settings.xml
sed -i -e "s|<url>__EXTERNAL_REPO_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml

export MAVEN_SETTINGS=$(pwd)/settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL

mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
    -e \
    -s $MAVEN_SETTINGS \
    -Dmaven.test.failure.ignore=true \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install

pushd maven-plugin-plugin
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/poms/
cp pom.xml $MAVEN_REPO_LOCAL/JPP/maven2/poms/JPP.maven2.plugins-plugin-plugin.pom
mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
    -e \
    -s $MAVEN_SETTINGS \
    -Dmaven.test.failure.ignore=true \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install || :
popd
cp pom.xml.sav0 pom.xml
mvn-jpp -Dmaven.compile.target=1.5 -Dmaven.javadoc.source=1.5  \
    -e \
    -s $MAVEN_SETTINGS \
    -Daggregate=true \
    -Dmaven.test.failure.ignore=true \
    -Dmaven2.jpp.depmap.file=%{SOURCE2} \
    -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
    install javadoc:javadoc || :


%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 maven-plugin-tools-ant/target/maven-plugin-tools-ant-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/ant-%{version}.jar
install -m 644 maven-plugin-tools-api/target/maven-plugin-tools-api-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar
install -m 644 maven-plugin-tools-beanshell/target/maven-plugin-tools-beanshell-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/beanshell-%{version}.jar
install -m 644 maven-plugin-tools-java/target/maven-plugin-tools-java-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/java-%{version}.jar
install -m 644 maven-plugin-tools-javadoc/target/maven-plugin-tools-javadoc-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/javadoc-%{version}.jar
install -m 644 maven-plugin-tools-model/target/maven-plugin-tools-model-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/model-%{version}.jar
install -m 644 maven-plugin-plugin/target/maven-plugin-plugin-%{version}.jar \
                $RPM_BUILD_ROOT%{_javadir}/%{name}/plugin-plugin-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; \
  do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -pm 644 pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{name}.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name} %{version} JPP/%{name} %{name}
%add_to_maven_depmap org.apache.maven %{name} %{version} JPP/%{name} %{name}
 
install -pm 644 maven-plugin-tools-ant/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-ant.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-ant %{version} JPP/%{name} ant
%add_to_maven_depmap org.apache.maven %{name}-ant %{version} JPP/%{name} ant

install -pm 644 maven-plugin-tools-api/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-api %{version} JPP/%{name} api
%add_to_maven_depmap org.apache.maven %{name}-api %{version} JPP/%{name} api

install -pm 644 maven-plugin-tools-beanshell/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-beanshell.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-beanshell %{version} JPP/%{name} beanshell
%add_to_maven_depmap org.apache.maven %{name}-beanshell %{version} JPP/%{name} beanshell

install -pm 644 maven-plugin-tools-java/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-java.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-java %{version} JPP/%{name} java
%add_to_maven_depmap org.apache.maven %{name}-java %{version} JPP/%{name} java

install -pm 644 maven-plugin-tools-javadoc/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-javadoc.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-javadoc %{version} JPP/%{name} javadoc
%add_to_maven_depmap org.apache.maven %{name}-javadoc %{version} JPP/%{name} javadoc

install -pm 644 maven-plugin-tools-model/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-model.pom
%add_to_maven_depmap org.apache.maven.plugin-tools %{name}-model %{version} JPP/%{name} model
%add_to_maven_depmap org.apache.maven %{name}-model %{version} JPP/%{name} model

install -pm 644 maven-plugin-plugin/pom.xml \
                $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-plugin-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-plugin-plugin %{version} JPP/%{name} plugin-plugin
%add_to_maven_depmap org.apache.maven.plugins maven-plugin-plugin %{version} JPP/%{name} plugin-plugin

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/

ln -s %{name}-%{version} \
     $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%files
%{_javadir}/%{name}
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/*
%endif

%files javadoc
%{_javadocdir}/*

%changelog
* Wed Feb 23 2011 Igor Vlasenko <viy@altlinux.ru> 0:2.4.3-alt2_4jpp6
- added qdox16-deps hack

* Tue Feb 22 2011 Igor Vlasenko <viy@altlinux.ru> 0:2.4.3-alt1_4jpp6
- new version

* Tue Feb 22 2011 Igor Vlasenko <viy@altlinux.ru> 0:2.1-alt4_2jpp6
- fixed build

* Sun Feb 20 2011 Igor Vlasenko <viy@altlinux.ru> 0:2.1-alt3_2jpp6
- fixed build

* Sun Jan 30 2011 Igor Vlasenko <viy@altlinux.ru> 0:2.1-alt2_2jpp6
- added depmap for org.apache.maven.plugin-tools

* Fri Sep 03 2010 Igor Vlasenko <viy@altlinux.ru> 0:2.1-alt1_2jpp6
- new version

